Index: code/branches/tetris/src/modules/pong/Pong.cc
===================================================================
--- code/branches/tetris/src/modules/pong/Pong.cc	(revision 8105)
+++ code/branches/tetris/src/modules/pong/Pong.cc	(revision 8106)
@@ -37,4 +37,6 @@
 #include "core/EventIncludes.h"
 #include "core/command/Executor.h"
+
+#include "gamestates/GSLevel.h"
 
 #include "PongCenterpoint.h"
@@ -158,8 +160,9 @@
             this->ball_->setBats(this->bat_);
         }
-        else // If no centerpoint was specified, an error is thrown.
+        else // If no centerpoint was specified, an error is thrown and the level is exited.
         {
             COUT(1) << "Error: No Centerpoint specified." << std::endl;
-            // TODO: End the game?
+            GSLevel::startMainMenu();
+            return;
         }
 
@@ -210,5 +213,5 @@
         Spawns the input player.
     @param player
-        The player tp be spawned.
+        The player to be spawned.
     */
     void Pong::spawnPlayer(PlayerInfo* player)
Index: code/branches/tetris/src/modules/pong/Pong.h
===================================================================
--- code/branches/tetris/src/modules/pong/Pong.h	(revision 8105)
+++ code/branches/tetris/src/modules/pong/Pong.h	(revision 8106)
@@ -47,9 +47,12 @@
     /**
     @brief
-        Implements a Pong minigame.
+        Implements a Pong minigame (<a href="http://en.wikipedia.org/wiki/Pong">Wikipedia::Pong</a>).
         It connects the different entities present in a game of Pong.
-        
-        //TODO: List and add details to different classes used and how.
-        PongBall, is the ball, PongBats are the things that can be moved by the players (ControllableEntities), PongCenterpoint is the playing field. (x-z area)
+
+        - The @ref orxonox::PongCenterpoint "PongCenterpoint" is the playing field for the Pong minigame, it allows for configuration of the minigame, e.g. by setting the size of the playing field, or the length of the @ref orxonox::PongBat "PongBats". The playing field is always in the x,y-plane, the x-axis being the horizontal and the z-axis being the vertical axis.<br />
+        The Pong class redistributes the important parameters defined in @ref orxonox::PongCenterpoint "PongCenterpoint" to the other entities, that need to know them, e.g. the @ref orxonox::PongBall "PongBall" and the @ref orxonox::PongBat "PongBats".<br />
+        The @ref orxonox::PongCenterpoint "PongCenterpoint" needs to exist in a level with the @ref orxonox::Gametype "Gametype" <em>Pong</em>.
+        - The @ref orxonox::PongBall "PongBall" is the ball both players play with. The @ref orxonox::PongBall "PongBall" both implements the movement of the ball, as well as the influence of the boundaries and consequently, also the bouncing (off the upper and lower delimiters, and as off the @ref orxonox::PongBat "PongBats") of the ball and the effects of the failure of a player to catch the ball (i.e. the scoring of the other player).
+        - The two @ref orxonox::PongBat "PongBats" are the entities through which the players can actively participate in the game, by controlling them. The @ref orxonox::PongBat "PongBat" class manages the movement (and restrictions thereof) and the influence of the players on the bats.
 
     @author
Index: code/branches/tetris/src/modules/pong/PongBall.cc
===================================================================
--- code/branches/tetris/src/modules/pong/PongBall.cc	(revision 8105)
+++ code/branches/tetris/src/modules/pong/PongBall.cc	(revision 8106)
@@ -144,5 +144,5 @@
                         // Set the ball to be exactly at the boundary.
                         position.x = this->fieldWidth_ / 2;
-                        // Invert its veloxity in x-direction (i.e. it bounces off).
+                        // Invert its velocity in x-direction (i.e. it bounces off).
                         velocity.x = -velocity.x;
                         // Adjust the velocity in the z-direction, depending on where the ball hit the bat.
@@ -171,5 +171,5 @@
                         // Set the ball to be exactly at the boundary.
                         position.x = -this->fieldWidth_ / 2;
-                        // Invert its veloxity in x-direction (i.e. it bounces off).
+                        // Invert its velocity in x-direction (i.e. it bounces off).
                         velocity.x = -velocity.x;
                         // Adjust the velocity in the z-direction, depending on where the ball hit the bat.
Index: code/branches/tetris/src/modules/pong/PongBall.h
===================================================================
--- code/branches/tetris/src/modules/pong/PongBall.h	(revision 8105)
+++ code/branches/tetris/src/modules/pong/PongBall.h	(revision 8106)
@@ -121,5 +121,4 @@
             void applyBats(); //!< Get the bats over the network.
 
-            // TODO: What is this exactly?
             static const float MAX_REL_Z_VELOCITY;
 
@@ -133,5 +132,5 @@
             float batlength_; //!< The length of the bats (in z-direction) as percentage of the height of the playing field.
             WeakPtr<PongBat>* bat_; //!< An array with the two bats.
-            bool bDeleteBats_; //!< Bool, to keep track, of whether bat_ exists or not.
+            bool bDeleteBats_; //!< Bool, to keep track, of whether this->bat_ exists or not.
             unsigned int* batID_; //!< The object IDs of the bats, to be able to synchronize them over the network.
             float relMercyOffset_; //!< Offset, that makes the player not loose, when, in all fairness, he would have.
Index: code/branches/tetris/src/modules/pong/PongBat.cc
===================================================================
--- code/branches/tetris/src/modules/pong/PongBat.cc	(revision 8105)
+++ code/branches/tetris/src/modules/pong/PongBat.cc	(revision 8106)
@@ -73,5 +73,5 @@
     @brief
         Is called each tick.
-        //TODO detailed
+        Moves the bat.
     @param dt
         The time since last tick.
@@ -87,5 +87,5 @@
                 this->movement_ = clamp(this->movement_, -1.0f, 1.0f) * this->speed_;
 
-                //TODO What does this?
+                //TODO: Why needed?
                 if (this->bMoveLocal_)
                     this->setVelocity(this->getOrientation() * Vector3(this->movement_, 0, 0));
@@ -96,4 +96,5 @@
                 this->bSteadiedPosition_ = false;
             }
+            // If there is no movement but the position has not been steadied, the velocity is set to zero and the position is reaffirmed.
             else if (!this->bSteadiedPosition_)
             {
Index: code/branches/tetris/src/modules/pong/PongBat.h
===================================================================
--- code/branches/tetris/src/modules/pong/PongBat.h	(revision 8105)
+++ code/branches/tetris/src/modules/pong/PongBat.h	(revision 8106)
@@ -45,11 +45,11 @@
     /**
     @brief
-        The PongBat class manages the bats for @ref orxonox::Pong "Pong", which are the elements controlled by the player.
-        
+        The PongBat class manages the bats for @ref orxonox::Pong "Pong", which are the elements controlled by the players.
+
         It is responsible for the movement (controlled by the players) of the bat.
-        
+
     @author
         Fabian 'x3n' Landau
-        
+
     @ingroup Pong
     */
@@ -110,9 +110,9 @@
 
             float movement_; //!< The amount (and direction), in z-direction, of movement of the bat.
-            bool bMoveLocal_; //TODO ???
-            float speed_; //!< The movementspeed of the bat.
+            bool bMoveLocal_; //!< Helper to know whether the movement is caused by moveFrontBack() or moveRightLeft().
+            float speed_; //!< The movement speed of the bat.
             float length_; //!< The length of the bat (in z-direction) as percentage of the height of the playing field.
             float fieldHeight_; //!< The height of the playing field.
-            bool bSteadiedPosition_; //TODO: ???
+            bool bSteadiedPosition_; //!< Helper boolean, to keep track of when to steady the position, to ensure network synchronicity.
     };
 }
Index: code/branches/tetris/src/modules/pong/PongCenterpoint.h
===================================================================
--- code/branches/tetris/src/modules/pong/PongCenterpoint.h	(revision 8105)
+++ code/branches/tetris/src/modules/pong/PongCenterpoint.h	(revision 8106)
@@ -56,5 +56,5 @@
         - The <b>balltemplate</b> is a template that is applied to the @ref orxonox::PongBall "PongBall", it can be used to attach different things to it, e.g. its @ref orxonox::Model "Model". See below for a usage example.
         - The <b>battemplate</b> is a template that is applied to the @ref orxonox::PongBall "PongBat", it can be used to attach different things to it, e.g. its @ref orxonox::Model "Model". See below for a usage example.
-        - The <b>ballspeed</b> is the speed with wich the @ref orxonox::PongBall "PongBall" moves. The default is <em>100</em>.
+        - The <b>ballspeed</b> is the speed with which the @ref orxonox::PongBall "PongBall" moves. The default is <em>100</em>.
         - The <b>ballaccfactor</b> is the acceleration factor for the @ref orxonox::PongBall "PongBall". The default is <em>1.0</em>.
         - The <b>batspeed</b> is the speed with which the @ref orxonox::PongBat "PongBats" move. The default is <em>60</em>.
@@ -223,5 +223,5 @@
 
             std::string balltemplate_; //!< The template for the ball.
-            std::string battemplate_; //!< The template for the batts.
+            std::string battemplate_; //!< The template for the bats.
 
             float ballspeed_; //!< The speed of then ball.
Index: code/branches/tetris/src/modules/pong/PongScore.h
===================================================================
--- code/branches/tetris/src/modules/pong/PongScore.h	(revision 8105)
+++ code/branches/tetris/src/modules/pong/PongScore.h	(revision 8106)
@@ -27,4 +27,10 @@
  */
 
+/**
+    @file PongScore.h
+    @brief Declaration of the PongScore class.
+    @ingroup Pong
+*/
+
 #ifndef _PongScore_H__
 #define _PongScore_H__
@@ -37,4 +43,8 @@
 namespace orxonox
 {
+
+    /**
+    
+    */
     class _PongExport PongScore : public OverlayText, public Tickable
     {