Index: code/branches/kicklib/cmake/PackageConfigOSX.cmake
===================================================================
--- code/branches/kicklib/cmake/PackageConfigOSX.cmake	(revision 8112)
+++ code/branches/kicklib/cmake/PackageConfigOSX.cmake	(revision 8113)
@@ -44,7 +44,8 @@
 SET(ENV{ALUTDIR}               ${DEP_FRAMEWORK_DIR})
 SET(ENV{BOOST_ROOT}            ${DEPENDENCY_PACKAGE_DIR})
-SET(ENV{CEGUIDIR}              ${DEP_FRAMEWORK_DIR})
-SET(ENV{LUA_DIR}               ${DEP_INCLUDE_DIR}/lua)
-SET(ENV{LUA5.1_DIR}            ${DEP_INCLUDE_DIR}/lua)
+SET(ENV{CEGUIDIR}              ${DEP_FRAMEWORK_DIR}/CEGUI.framework)
+SET(ENV{CEGUILUADIR}           ${DEP_FRAMEWORK_DIR}/CEGUILuaScriptModule.framework)
+SET(ENV{CEGUITOLUADIR}         ${DEP_FRAMEWORK_DIR}/ceguitolua++.framework)
+SET(ENV{LUA5.1_DIR}            $ENV{CEGUILUADIR}/Versions/A/Resources/lua.framework
 SET(ENV{OGGDIR}                ${DEP_INCLUDE_DIR})
 SET(ENV{VORBISDIR}             ${DEP_INCLUDE_DIR})
Index: code/branches/kicklib/cmake/tools/FindCEGUI.cmake
===================================================================
--- code/branches/kicklib/cmake/tools/FindCEGUI.cmake	(revision 8112)
+++ code/branches/kicklib/cmake/tools/FindCEGUI.cmake	(revision 8113)
@@ -34,5 +34,5 @@
 FIND_PATH(CEGUI_INCLUDE_DIR CEGUI.h
   PATHS $ENV{CEGUIDIR}
-  PATH_SUFFIXES include include/CEGUI CEGUI.framework/Headers
+  PATH_SUFFIXES include include/CEGUI Headers
 )
 
@@ -44,5 +44,5 @@
   NAMES CEGUIBase CEGUI
   PATHS $ENV{CEGUIDIR}
-  PATH_SUFFIXES lib bin CEGUIBase.framework CEGUI.framework
+  PATH_SUFFIXES lib bin
 )
 FIND_LIBRARY(CEGUI_LIBRARY_DEBUG
@@ -56,16 +56,19 @@
 # Find CEGUILua headers
 FIND_PATH(CEGUILUA_INCLUDE_DIR CEGUILua.h
-  PATHS $ENV{CEGUIDIR} ${CEGUI_INCLUDE_DIR}/ScriptingModules/LuaScriptModule
-  PATH_SUFFIXES include include/CEGUI CEGUILuaScriptModule.framework/Headers
+  PATHS
+    $ENV{CEGUIDIR}
+    $ENV{CEGUILUADIR}
+    ${CEGUI_INCLUDE_DIR}/ScriptingModules/LuaScriptModule
+  PATH_SUFFIXES include include/CEGUI Headers
 )
 # Find CEGUILua libraries
 FIND_LIBRARY(CEGUILUA_LIBRARY_OPTIMIZED
   NAMES CEGUILua CEGUILuaScriptModule
-  PATHS $ENV{CEGUIDIR}
-  PATH_SUFFIXES lib bin CEGUILuaScriptModule.framework
+  PATHS $ENV{CEGUIDIR} $ENV{CEGUILUADIR}
+  PATH_SUFFIXES lib bin
 )
 FIND_LIBRARY(CEGUILUA_LIBRARY_DEBUG
   NAMES CEGUILuad CEGUILua_d CEGUILuaScriptModuled CEGUILuaScriptModule_d
-  PATHS $ENV{CEGUIDIR}
+  PATHS $ENV{CEGUIDIR} $ENV{CEGUILUADIR}
   PATH_SUFFIXES lib bin
 )
@@ -79,18 +82,18 @@
     # For newer CEGUI versions >= 0.7
     ${CEGUILUA_INCLUDE_DIR}/support/tolua++
-    # For Apples
-    $ENV{CEGUIDIR}
-  PATH_SUFFIXES ceguitolua++.framework/Headers
-  NO_DEFAULT_PATH # MUST be in CEGUILUA_INCLUDE_DIR somewhere
+    # For Mac OS X, tolua++ is a separate framework in the dependency package
+    $ENV{CEGUITOLUADIR}
+  PATH_SUFFIXES Headers
+  NO_DEFAULT_PATH # Don't attempt to find tolua++ installed on the system
 )
 # Find CEGUI Tolua++ libraries
 FIND_LIBRARY(CEGUI_TOLUA_LIBRARY_OPTIMIZED
   NAMES CEGUItoluapp tolua++ ceguitolua++
-  PATHS $ENV{CEGUIDIR}
-  PATH_SUFFIXES lib bin ceguitolua++.framework
+  PATHS $ENV{CEGUIDIR} ${CEGUITOLUADIR}
+  PATH_SUFFIXES lib bin
 )
 FIND_LIBRARY(CEGUI_TOLUA_LIBRARY_DEBUG
   NAMES CEGUItoluappd CEGUItoluapp_d tolua++d tolua++_d
-  PATHS $ENV{CEGUIDIR}
+  PATHS $ENV{CEGUIDIR} ${CEGUITOLUADIR}
   PATH_SUFFIXES lib bin
 )
@@ -101,16 +104,19 @@
   # Find CEGUI OGRE Renderer headers
   FIND_PATH(CEGUI_OGRE_RENDERER_INCLUDE_DIR CEGUIOgreRenderer.h
-    PATHS $ENV{CEGUIDIR} ${CEGUI_INCLUDE_DIR}/RendererModules/Ogre
-    PATH_SUFFIXES include include/CEGUI CEGUI.framework/Headers
+    PATHS
+      $ENV{CEGUIDIR}
+      $ENV{CEGUIOGRERENDERERDIR}
+      ${CEGUI_INCLUDE_DIR}/RendererModules/Ogre
+    PATH_SUFFIXES include include/CEGUI Headers
   )
   # Find CEGUI OGRE Renderer libraries
   FIND_LIBRARY(CEGUI_OGRE_RENDERER_LIBRARY_OPTIMIZED
     NAMES CEGUIOgreRenderer
-    PATHS $ENV{CEGUIDIR}
+    PATHS $ENV{CEGUIDIR} $ENV{CEGUIOGRERENDERERDIR}
     PATH_SUFFIXES lib bin
   )
   FIND_LIBRARY(CEGUI_OGRE_RENDERER_LIBRARY_DEBUG
     NAMES CEGUIOgreRendererd CEGUIOgreRenderer_d
-    PATHS $ENV{CEGUIDIR}
+    PATHS $ENV{CEGUIDIR} $ENV{CEGUIOGRERENDERERDIR}
     PATH_SUFFIXES lib bin
   )
Index: code/branches/kicklib/cmake/tools/FindLua5.1.cmake
===================================================================
--- code/branches/kicklib/cmake/tools/FindLua5.1.cmake	(revision 8112)
+++ code/branches/kicklib/cmake/tools/FindLua5.1.cmake	(revision 8113)
@@ -56,6 +56,6 @@
 # Find include path
 FIND_PATH(LUA5.1_INCLUDE_DIR lua.h
-  PATHS $ENV{LUA5.1_DIR}
-  PATH_SUFFIXES include/lua51 include/lua5.1 include/lua include
+  PATHS $ENV{LUA5.1_DIR} $ENV{LUA_DIR}
+  PATH_SUFFIXES include/lua51 include/lua5.1 include/lua include Headers
 )
 